////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
Project 015 - LCD Driver for LPH7653-1
CCS compiler
		
by Michel Bavin (c) September 25, 2004. --- bavin@skynet.be --- http://users.skynet.be/bk317494/ ---  

... enjoy !

Open source for personal or educational use only.
*/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <18f452.h>			// device selection  
#device adc=10  *=16 

#fuses XT,NOWDT,NOPROTECT,NOLVP,PUT,NOBROWNOUT,NOOSCSEN,CCP2C1,NOSTVREN,NODEBUG  

#use delay(clock=4000000) 	// 4 MhZ  ! ADC is not optimal at 20 MhZ + power consumption doubles

#use rs232(baud=19200, xmit=PIN_C6, rcv=PIN_C7)
#use i2c(master, sda=PIN_C4, scl=PIN_C3, fast) 

#zero_ram 

// #PRIORITY  

#use fast_io(A)
#use fast_io(B)
#use fast_io(C)
#use fast_io(D)
#use fast_io(E)

#define NOP #asm nop #endasm

#byte pa	=0xF80	//port a	// analog
#byte pb	=0xF81	//b			// spi & sensor controls
#byte pc	=0xF82	//c			// ic & timing
#byte pd	=0xF83	//d			// LCD 
#byte pe	=0xF84	//port e	// keys

// *********************************
// PORT A
// analog inputs 



// *********************************
// PORT B: 


// *********************************
// PORT C 
// ic 


// RC3 pin18 = SCL ic 			// already defined (hardware)
// RC4 pin23 = SDA ic

// RC6 pin25 = RS232 TX			// already defined (hardware)
// RC7 pin26 = RS232 RX

// *********************************
// PORT D
// 

#bit backlight	=pd.0			// RD1 pin19
#bit led 		=pd.1			// RD1 pin20

// *********************************
// PORT E

// *********************************


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char a,b;

//
char x,y,char_row,charsel,charpos,chardata,xaxe,yaxe,invert_vid; 		// for lph7653 lcd
short invert_lcd_video;
char plot_value,dataforlcd;
int32 plot_value32;
int32 plot_umsb,plot_lmsb,plot_ulsb,plot_llsb;
#include <lph7653_v2.c>
//


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------

void main(){


SET_TRIS_A(0x00);		// oooo oooo
SET_TRIS_B(0x00);		// oooo oooo	
SET_TRIS_C(0x02);		// oooo ooio
SET_TRIS_D(0x00);		// oooo oooo
SET_TRIS_E(0x00);		// oooo oooo	

printf("LPH7653-1\n\r");		// RS232 test

led=0;			// test LED is OFF
backlight=1;	// LCD backlight is ON

//

lcd_cls();			// clear LCD

invert_lcd_video=FALSE;

lcd_gotoxy(0,0);
printf(lcd_text,"*LPH7653-1 test.");
lcd_gotoxy(0,1);
printf(lcd_text,"*  Enjoy it!!");

delay_ms(1000);	// test
backlight=0;	// LCD backlight is OFF

/////////////////////////////////////////////
while(1) 
{ 
lcd_gotoxy(0,0);
printf(lcd_text,"*LPH7653-1 test.");
lcd_gotoxy(0,1);
printf(lcd_text,"*  Enjoy it!!");

lcd_gotoxy(0,3);
printf(lcd_text,"+--**********--+");

led=1;delay_ms(500);		// test

lcd_gotoxy(0,1);
lcd_clear_y(3);
lcd_clear_x(0);


led=0;delay_ms(500);		// test
lcd_cls();					// clear LCD

b=0;
for (a=0;a!=96;a++){		// test graphic
	b++;
	if (b>31){b=0;}
	lcd_plot(a,b);
					}




delay_ms(1000);		// test
lcd_cls();			// clear LCD



} //end while 

		} //end main 


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//												The End !!!!
